#!/bin/bash

STPATH="/etc/static-routes"
UPINTPATH="/var/lib/network"
ROUTESCONFFILE="/etc/sysconfig/network-scripts/multiroutes.cfg"

EXTDEV=( "" )
i=0

while read line
    do
	if [ -e "$UPINTPATH/$line" -a "$(ifconfig | grep $line)" != "" ]
	    then
		EXTDEV[$i]=$line
		i=$[$i+1]
	fi
    done < <(cat $ROUTESCONFFILE | grep -v "#" | grep "GLOBAL" | awk -F' ' '{print $2}')

if [ "${#EXTDEV[@]}" -gt 1 ]
    then
	DEFROUTE=""
	i=0
	while [ "$i" -lt ${#EXTDEV[@]} ]
	    do
		GW=$(cat /etc/sysconfig/network-scripts/ifcfg-${EXTDEV[$i]} | grep GATEWAY | awk -F'=' '{print $2}')
		DEFROUTE="$DEFROUTE nexthop via $GW dev ${EXTDEV[$i]}"
		i=$[$i+1]
	    done
	if [ "$(ip route | grep "default equalize")" == "" ]
	    then
		ip route del default
		ip route add default equalize $DEFROUTE
	    elif [ "${#EXTDEV[@]}" -gt 2 ]
		then
		    i=0
		    FLAG=1
		    while [ "$i" -lt ${#EXTDEV[@]} ]
			do
			    if [ "$(ip route | grep "nexthop" | grep ${EXTDEV[$i]})" == "" ]
				then
				    FLAG=0
			    fi
			    i=$[$i+1]
			done
		    if [ "$FLAG" = 0 ]
			then
			    ip route del default
			    ip route add default equalize $DEFROUTE
		    fi
	fi
fi

exit 0
