#!/bin/bash

ETH=$1
TBR=$2
STPATH="/etc/static-routes"
ROUTESCONFFILE="/etc/sysconfig/network-scripts/multiroutes.cfg"

funk_read_array_from_file ()
{
    VAR_DATA=( "" )
    ind=0
    while read line
#    for line in `cat $1 | grep -v "#" | awk -F' //' '{print $1}'`
	do
	    if [ "$line" != "" ]
		then
		    VAR_DATA[$ind]=$line
		    ind=$[$ind+1]
	    fi
	done < <(cat $1 | grep -v "#" | awk -F' //' '{print $1}')
}

VAR_DATA=( "" )
funk_read_array ()
{
    VAR_DATA=( "" )
    ind=0
    for line in `cat $STPATH/$1 | grep -v "#" | awk -F' //' '{print $1}'`
	do
	    if [ "$line" != "" ]
		then
		    VAR_DATA[$ind]=$line
		    ind=$[$ind+1]
	    fi
	done
}

funk_read_netif ()
{
while read line
    do
	case $(echo $line | awk -F'=' '{print $1}') in
	    "IPADDR")
		IP=$(echo $line | awk -F'=' '{print $2}')
		;;
	    "PREFIX")
		PREFIX=$(echo $line | awk -F'=' '{print $2}')
		;;
	    "GATEWAY")
		GW=$(echo $line | awk -F'=' '{print $2}')
		;;
	esac
    done < <(cat /etc/sysconfig/network-scripts/ifcfg-$1)
    NET_NET[$i]=`funk_net_ip $IP $PREFIX`
}

funk_net_ip ()
{
    LANIP=$1
    NET_PREF=$2
    AT=( "" )
    i=0
    PIP0=$(echo $LANIP | awk -F'.' '{print $1}')
    PIP1=$(echo $LANIP | awk -F'.' '{print $2}')
    PIP2=$(echo $LANIP | awk -F'.' '{print $3}')
    PIP3=$(echo $LANIP | awk -F'.' '{print $4}')
    PBT=$(( 2 ** $(( $NET_PREF / 8 * 8 + 8 - $NET_PREF ))))
    case $(( $NET_PREF / 8 )) in
	"0")
	    NIP=$(($PIP0 / $PBT * $PBT))
	    AT="$NIP.0.0.0"
	    ;;
	"1")
	    NIP=$(($PIP1 / $PBT * $PBT))
	    AT="$PIP0.$NIP.0.0"
	    ;;
	"2")
	    NIP=$(($PIP2 / $PBT * $PBT))
	    AT]="$PIP0.$PIP1.$NIP.0"
	    ;;
	"3")
	    NIP=$(($PIP3 / $PBT * $PBT))
	    AT="$PIP0.$PIP1.$PIP2.$NIP"
	    ;;
    esac 
    echo $AT
}

IP=""
GW=""
PREFIX=""
NET_NET=""

ROUTESCONFFILE="/etc/sysconfig/network-scripts/multiroutes.cfg"

funk_read_array_from_file $ROUTESCONFFILE
funk_read_netif $ETH

STATIC_ROUTE="/etc/sysconfig/network-scripts/route-$ETH"

#GW=$(cat /etc/sysconfig/network-scripts/ifcfg-$ETH | grep GATEWAY | awk -F'=' '{print $2}')
#IP=$(cat /etc/sysconfig/network-scripts/ifcfg-$ETH | grep IPADDR | awk -F'=' '{print $2}')

ROUTELIST=""

STRG=$(cat $ROUTESCONFFILE | grep -v "#" | grep $ETH)
if [ "$(echo $STRG | awk -F': ' '{print $1}')" == "LOCAL" ]
    then 
	CTGL=$(cat $ROUTESCONFFILE | grep -v "#" | grep -c "GLOBAL")
#	LIP=$(cat /etc/sysconfig/network-scripts/ifcfg-$ETH | grep IPADDR | awk -F'=' '{print $2}')
	LOCNET="$NET_NET/$PREFIX"
	#$(echo $STRG | awk -F' ' '{print $3}')
	i=0
	while [ "$i" -lt "$CTGL" ]
	    do
		i=$[$i+1]
		ROUTELIST="$ROUTELIST$LOCNET via $IP table $i""\n"
	    done
	echo -e $ROUTELIST  > $STATIC_ROUTE
    elif [ "$(echo $STRG | awk -F': ' '{print $1}')" == "GLOBAL" ]
	then
	ROUTELIST="$ROUTELIST""0/0 via $GW table $TBR""\n"
	funk_read_array $ETH
	i=0
	while [ "$i" -lt ${#VAR_DATA[@]} ]
	    do
		ROUTELIST="$ROUTELIST""${VAR_DATA[$i]} dev $ETH src $IP""\n"
		i=$[$i+1]
	    done
	echo -e $ROUTELIST > $STATIC_ROUTE
fi

exit 0

VAR_DATA=( "" )

